'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = xhrRequest;
var XHR = exports.XHR = 'xhr';

function xhrRequest(options) {
  var xhr = new XMLHttpRequest();
  var index = 0;

  function onProgressEvent() {
    var rawChunk = xhr.responseText.substr(index);
    index = xhr.responseText.length;
    options.onRawChunk(rawChunk);
  }

  function onLoadEvent() {
    options.onComplete({
      statusCode: xhr.status,
      transport: XHR,
      raw: xhr
    });
  }

  xhr.open(options.method, options.url);
  xhr.responseType = 'text';
  if (options.headers) {
    Object.getOwnPropertyNames(options.headers).forEach(function (k) {
      xhr.setRequestHeader(k, options.headers[k]);
    });
  }
  if (options.credentials === 'include') {
    xhr.withCredentials = true;
  }
  xhr.addEventListener('progress', onProgressEvent);
  xhr.addEventListener('load', onLoadEvent);
  xhr.send(options.body);
}